from flask import request, jsonify, make_response
from database.crud import insert_data, verify_otp
from app.twilio import send_otp
from app import app


@app.route("/register", methods=["POST"])
def create_user():
    data = request.get_json()
    insert_data(schema="Users", data=data)
    send_otp(receiver=data["mobile"])
    return make_response(jsonify("User created, pending OTP verification"))


@app.route("/verifyotp", methods=["POST"])
def validate_otp():
    data = request.get_json()
    if verify_otp(mobile=data["mobile"], otp=data["otp"]):
        return make_response(jsonify("The OTP has been verified successfully"))
    return make_response(jsonify("The OTP is not correct"))
